Description

On Mac OS X, using macports I encountered a compilation problem related to swig and file permissions:

When calling make from the gamma lib directory, the compilation fails when building app_wrap

/usr/bin/clang -fno-strict-aliasing -fno-common -dynamic -pipe -Os -fwrapv -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes

 -I../include -I/opt/local/Library/Frameworks/Python.framework/Versions/2.7/include/python2.7 -I/opt/local/include -I../inst/mwl/include

 -I../inst/cta/include -I../inst/lat/include -I../inst/com/include

 -I/opt/local/Library/Frameworks/Python.framework/Versions/2.7/include/python2.7 -c gammalib/app_wrap.cpp -o

 build/temp.macosx-10.9-x86_64-2.7/gammalib/app_wrap.o

gammalib/app_wrap.cpp:871:38: warning: format string is not a string literal (potentially insecure) [-Wformat-security]

    PyErr_Format(PyExc_RuntimeError, mesg);

                                     ^~~~

gammalib/app_wrap.cpp:2031:11: warning: explicitly assigning a variable of type 'int' to itself [-Wself-assign]

                    res = SWIG_AddCast(res);

                    ~~~ ^              ~~~

gammalib/app_wrap.cpp:2034:11: warning: explicitly assigning a variable of type 'int' to itself [-Wself-assign]

                    res = SWIG_AddCast(res);

                    ~~~ ^              ~~~

gammalib/app_wrap.cpp:11549:55: error: use of undeclared identifier 'SWIG_PyInstanceMethod_New'

         { (char *)"SWIG_PyInstanceMethod_New", (PyCFunction)SWIG_PyInstanceMethod_New, METH_O, NULL},

                                                             ^

gammalib/app_wrap.cpp:11827:72: error: cannot initialize a member subobject of type 'swig_converter_func' (aka 'void *(*)(void *)')

 with an lvalue of type 'void *(void *, int *)':

      different number of parameters (1 vs 2)

static swig_cast_info _swigc__p_GBase[] = {  {&_swigt__p_GApplication, _p_GApplicationTo_p_GBase, 0, 0}, 

 {&_swigt__p_GApplicationPar, _p_GApplicationParTo_p_GBase, 0, 0},  ...

                                                                       ^~~~~~~~~~~~~~~~~~~~~~~~~

gammalib/app_wrap.cpp:11827:136: error: cannot initialize a member subobject of type 'swig_converter_func' (aka 'void *(*)(void *)')

 with an lvalue of type 'void *(void *, int *)':

      different number of parameters (1 vs 2)

static swig_cast_info _swigc__p_GBase[] = {  {&_swigt__p_GApplication, _p_GApplicationTo_p_GBase, 0, 0}, 

 {&_swigt__p_GApplicationPar, _p_GApplicationParTo_p_GBase, 0, 0},  {&_swig...

                                                                                                                                       ^~~~~~~~~~~~~~~~~~~~~~~~~~~~

gammalib/app_wrap.cpp:11827:228: error: cannot initialize a member subobject of type 'swig_converter_func' (aka 'void *(*)(void *)')

 with an lvalue of type 'void *(void *, int *)':

      different number of parameters (1 vs 2)

  ...0, 0},  {&_swigt__p_GApplicationPar, _p_GApplicationParTo_p_GBase, 0, 0},  {&_swigt__p_GBase, 0, 0, 0}, 

 {&_swigt__p_GContainer, _p_GContainerTo_p_GBase, 0, 0},  {&_swigt__p...

                                                                                                                                      ^~~~~~~~~~~~~~~~~~~~~~~

gammalib/app_wrap.cpp:11827:291: error: cannot initialize a member subobject of type 'swig_converter_func' (aka 'void *(*)(void *)')

 with an lvalue of type 'void *(void *, int *)':

      different number of parameters (1 vs 2)

  ...0, 0},  {&_swigt__p_GBase, 0, 0, 0},  {&_swigt__p_GContainer, _p_GContainerTo_p_GBase, 0, 0}, 

 {&_swigt__p_GApplicationPars, _p_GApplicationParsTo_p_GBase, 0, 0},{0, 0, 0, 0}};

                                                                                                                                  ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~

gammalib/app_wrap.cpp:11919:14: warning: explicitly assigning a variable of type 'void *' to itself [-Wself-assign]

  clientdata = clientdata;

  ~~~~~~~~~~ ^ ~~~~~~~~~~

4 warnings and 5 errors generated.

error: command '/usr/bin/clang' failed with exit status 1

make[3]: *** [build] Error 1
make[2]: *** [all] Error 2

make[1]: *** [all-recursive] Error 1

make: *** [all] Error 2

It is not clear to me where this problem is coming from, but it might be related to file permissions. If you run a "sudo make" instead of

a "make", the compilation proceeds without any problems. Even the clang command to build app_wrap is exactly the same, and was

also cross-checked with an independent compilation on Christophs machine.

I've traced the problem as far as to the files, where SWIG_AddCast() is declared(?). The files are called pycomplex.py,

pyprimtypes.py and pyrun.swg and are located in the /opt/local/share/swig/3.0.2/python folder of macports.

History

#1 - 07/09/2014 11:17 PM - Knödlseder Jürgen

- Description updated

#2 - 07/09/2014 11:21 PM - Knödlseder Jürgen

Can it be that you did a sudo make install before, and by chance this did compile some stuff before installing the library?

If you call sudo make install with some things that still needs to be compiled (for example in case you changed some file), the remaining compiled

stuff will be owned by root, hence when you want to compile later you get an permission error.

You may use sudo chown -R stefan:stefan * (or whatever your user and group is) to make sure that all permission are set correctly. After that I would

guess that make will work again.

#3 - 07/10/2014 12:03 AM - Ohm Stefan

The problem could be reproduced with two clean checkouts of gammalib, and compiling one with "make" and the other one with "sudo make". Maybe

these problems are indeed related to some file permission settings specific to my system. I suppose we can stop working on that bug unless someone

else stumbles over it.

#4 - 07/10/2014 10:58 AM - Deil Christoph

After thinking about it some more, I don't think the issue is file permissions.

If file permission were the issue, the error message should say so, but it says:

gammalib/app_wrap.cpp:11549:55: error: use of undeclared identifier 'SWIG_PyInstanceMethod_New'

At this point one needs to look into and to a certain degree understand the SWIG (and maybe Python) header files.

My advice would be to completely remove and re-install Macports ... it takes an hour of your time and a few hours download / install time on your

Macbook, but my guess is that the issue will disappear and it's probably pain than trying to understand how SWIG works.

I'm against simply closing this issue without making `./configure && make` (without `sudo` work), otherwise we might get less computer-savvy users

that get frustrated in the future if it's a real issue in the `GammaLib` build system.
#5 - 07/10/2014 02:07 PM - Ohm Stefan

Hi Christoph,

I've completely removed and re-installed macports with exactly the same result...

Cheers, Stefan

#6 - 10/30/2014 11:32 AM - Knödlseder Jürgen

Any news on that one? Is there still a problem?

#7 - 10/30/2014 01:10 PM - Ohm Stefan

I made a clean installation of macports again and the problem is still there. Nothing changed, even after upgrading to Yosemite.

#8 - 10/30/2014 01:57 PM - Knödlseder Jürgen

- Priority changed from Normal to High

I cannot see how gammalib can screw things up as it will only work in the gammalib folder. So in case you have correct access rights there it should

be okay.

So my suspicion is more on the swig side. Have you tried installing swig from source?  You can get the source from http://www.swig.org/ and I think

installation is pretty easy (I did this at least on a bunch of Linux virtual machines). This may at least give you full control over swig and the its

permissions, to see whether it solves your issue.

#9 - 11/03/2014 08:58 AM - Ohm Stefan

- Status changed from New to Resolved

- % Done changed from 0 to 100

Hi Juergen,

I found the problem that caused that odd error. It was related to a conflict between the swig version installed via macports and the one shipped with

the Fermi Science Tools. The Fermi login script sets the $SWIG_LIB variable to the Fermi swig version, whereas the compilation was done with the

macports version that by default doesn't set any $SWIG_LIB variable. At some point there was then a conflict between the two versions.

Cheers, Stefan

#10 - 02/08/2015 08:56 PM - Knödlseder Jürgen

- Status changed from Resolved to Closed

Files

check.out 28.6 KB 07/09/2014 Ohm Stefan

configure.out 11.4 KB 07/09/2014 Ohm Stefan

make.out 240 KB 07/09/2014 Ohm Stefan

test-suite.log 774 Bytes 07/09/2014 Ohm Stefan
